(* from handout *)

val x = 5

val l = nil

fun f x = x

val compose = fn f => fn g => fn x => f (g x)

fun g x = x + 7

structure S : sig type t end =
  struct
    type t = int
  end

structure S :> sig type t end =
  struct
    type t = int
  end

structure S = struct val i = 5 end
open S
val j = i

structure Shadow =
  struct
    val x = 5
    val x = true
    val x = nil
  end

structure Coerce :
  sig
    val z : int
    val y : int
  end =
  struct
    val x = 5
    val y = x + 7
    val z = y * 12
  end


(* more interesting *)

(* mmm, type abstraction! *)
structure List :>
    sig
        type 'a t

        val hd : int t -> int
        val tl : int t -> int t
    end =
    struct
        type 'a t = 'a list

        (* loop on bad input *)
        fun loop x = loop x

        fun hd l =
            case (l : int list) of
                nil => loop 0
              | x::xs => x

        fun tl l =
            case (l : int list) of
                nil => loop 0
              | x::xs => xs
    end

(* make mine with coconut milk *)
structure Fun =
    struct
        type ('a, 'b, 'c) tupled = 'a * 'b -> 'c
        type ('a, 'b, 'c) curried = 'a -> 'b -> 'c

        fun curry tupled = fn a => fn b => tupled (a, b)
        fun tuple curried = fn p => curried (#1 p) (#2 p)
    end

(* arbitrary precision but very slow natural numbers *)
structure Nat :>
    sig
        type nat
        val zero : nat
        val succ : nat -> nat
        (* iter monomorphized to type int, so the signature matching works *)
        val iter : nat -> int -> (int -> int) -> int
    end =
    struct
        type nat = int list
        val zero = [] : nat
        fun succ n = 0 :: n
        fun iter n =
            (* sprinkle enough type annotations to monomorphize everything *)
            (* (makes me wish i would have supported optional types on idents!
                ... almost ...) *)
            fn z => fn s =>
            case (n : nat) of
                nil => (z : int)
              | x::xs => s (iter xs z s)
    end

(* what examples.sml would be complete without factorial? *)
structure Fact =
    struct
        fun fact x =
            if x = 0 then
                1
            else
                x * fact (x - 1)
    end

(* let's pollute the namespace a bit, for fun and profit *)
open Fact
val fact5 = fact 5

(* hmm... we should use our library!  and test shadowing... *)
fun fact nat =
    let fun nat_to_int n = Nat.iter n 0 (fn x => x + 1)
    in
        Nat.iter nat 1 (fn fact_pred_n => nat_to_int nat * fact_pred_n)
    end
val factsssss0 =
    fact (Nat.succ (Nat.succ (Nat.succ (Nat.succ (Nat.succ Nat.zero)))))

(* perhaps that's enough for one night... if you have any interesting or
   difficult test cases, feel free to send them in! *)
