
structure Util :> UTIL =
struct

  fun uncurry f (a,b) = f a b
  fun curry f a b = f (a, b)

  fun uncurry3 f (a, b, c) = f a b c
  fun curry3 f a b c = f (a, b, c)

  fun uncurry4 f (a, b, c, d) = f a b c d
  fun curry4 f a b c d = f (a, b, c, d)

  fun both f g x = (f x, g x)
  fun doboth f g x = (ignore (f x); ignore (g x))

  fun for lo hi f =
      if lo > hi then ()
      else (ignore (f lo); for (lo + 1) hi f)

  fun ford lo hi b f =
      if lo > hi then b
      else (ford (lo + 1) hi (f (lo, b)) f)

  datatype ('a, 'b) sum = A of 'a | B of 'b


  fun I x = x
  fun K x y = x

  fun opandalso (a, b) = a andalso b
  fun oporelse  (a, b) = a orelse b

  fun option_compare _ (NONE, NONE) = EQUAL
    | option_compare _ (SOME _, NONE) = GREATER
    | option_compare _ (NONE, SOME _) = LESS
    | option_compare f (SOME x, SOME y) = f(x, y)

  fun lex_order oa ob ((a, b), (aa, bb)) =
    (case oa (a, aa) of
       LESS => LESS
     | GREATER => GREATER
     | EQUAL => ob (b, bb))

  fun c21 f a b = f b a


  fun c132 f a1 a3 a2 = f a1 a2 a3
  fun c213 f a2 a1 a3 = f a1 a2 a3
  fun c231 f a2 a3 a1 = f a1 a2 a3
  fun c312 f a3 a1 a2 = f a1 a2 a3
  fun c321 f a3 a2 a1 = f a1 a2 a3

  fun c1243 f a1 a2 a4 a3 = f a1 a2 a3 a4
  fun c1324 f a1 a3 a2 a4 = f a1 a2 a3 a4
  fun c1342 f a1 a3 a4 a2 = f a1 a2 a3 a4
  fun c1423 f a1 a4 a2 a3 = f a1 a2 a3 a4
  fun c1432 f a1 a4 a3 a2 = f a1 a2 a3 a4
  fun c2134 f a2 a1 a3 a4 = f a1 a2 a3 a4
  fun c2143 f a2 a1 a4 a3 = f a1 a2 a3 a4
  fun c2314 f a2 a3 a1 a4 = f a1 a2 a3 a4
  fun c2341 f a2 a3 a4 a1 = f a1 a2 a3 a4
  fun c2413 f a2 a4 a1 a3 = f a1 a2 a3 a4
  fun c2431 f a2 a4 a3 a1 = f a1 a2 a3 a4
  fun c3124 f a3 a1 a2 a4 = f a1 a2 a3 a4
  fun c3142 f a3 a1 a4 a2 = f a1 a2 a3 a4
  fun c3214 f a3 a2 a1 a4 = f a1 a2 a3 a4
  fun c3241 f a3 a2 a4 a1 = f a1 a2 a3 a4
  fun c3412 f a3 a4 a1 a2 = f a1 a2 a3 a4
  fun c3421 f a3 a4 a2 a1 = f a1 a2 a3 a4
  fun c4123 f a4 a1 a2 a3 = f a1 a2 a3 a4
  fun c4132 f a4 a1 a3 a2 = f a1 a2 a3 a4
  fun c4213 f a4 a2 a1 a3 = f a1 a2 a3 a4
  fun c4231 f a4 a2 a3 a1 = f a1 a2 a3 a4
  fun c4312 f a4 a3 a1 a2 = f a1 a2 a3 a4
  fun c4321 f a4 a3 a2 a1 = f a1 a2 a3 a4


  structure Oneshot =
  struct
      fun I x = x
      exception Oneshot of string

      (* A if unset (holds fn to apply)
         B if set (holds final value) *)
      type 'a oneshot = (('a -> 'a, 'a) sum) ref
      fun oneshot () = ref (A I)
      fun init a = ref (B a)
      fun set (ref (B _), _) = raise Oneshot "Oneshot already set!"
        | set (r as ref (A f), a) = r := B (f a)

      fun deref (ref (B b)) = SOME b
        | deref (ref (A _)) = NONE

      val eq = op =

      fun wrap f os =
          case !os of
              B v => os := B (f v)
            | A g => os := A (f o g)
  end

end
